#!/usr/bin/python3

import os, sys, argparse, json, datetime

from jinja2 import Environment

# TODO: Increase indentation level for each namespace def
declarations_template = """
/*
 *  WARNING: This file is generated by 'enum2str'. Any changes made here will 
 *  be destroyed next time the tool is run. 
 *
 *  @date: {{ date }}
 */

#pragma once
#include <string>

{% for include in includes -%}
#include {{ include }}
{% endfor %}


{% for enum in enums %}

{% for namespace in enum.namespace -%}
namespace {{ namespace }} {
{% endfor %}

    {% if enum.doc_comment|length > 1 %}
    /**
     * {{ enum.doc_comment }}
     */
     {% endif %}
    enum class {{ enum.name }} {
    {% for entry in enum.entries %}
    {% if entry|length == 1 %}
        {{ entry }}, 
    {% elif entry|length >= 2 %}
        {{ entry[0] }} = {{ entry[1] }},
    {% else %}
        Error: Empty enumeration field
    {% endif %}
    {% endfor %}
    };


    /** 
     * Convert a {{ enum.name }} to a std::string
     *
     * The generated string is simply a stringification of the name of the enum value. It can be used to
     * to and from the enum in conjunction with #to_{{ enum.name }}
     * 
     * @param value The {{ enum.name }} to convert
     * @return A stringified representation of \p value
     */
    std::string to_string(const {{ enum.name }} value);

    
    /** 
     * Convert a {{ enum.name }} to a std::string
     *
     * A description of the enum value
     * 
     * @param value The {{ enum.name }} for which to retrieve the description
     * @return The description of the \p value
     */
    std::string get_description(const {{ enum.name }} value);

    
    /**
     * Convert a std::string to a {{ enum.name }} value.
     *
     * @param value The stringified version of an {{ enum.name }} field to convert back to a {{ enum.name }}.
     * @return The {{ enum.name }} value.
     */
    {{enum.name}} to_{{ enum.name }}(const std::string & value);
{% for namespace in enum.namespace %}
} // end namespace {{ namespace }}
{% endfor %}
{% else %}
// No enums found in config
{% endfor %} {# for enum in enums #}

"""

definitions_template = """
/*
 *  WARNING: This file is generated by 'enum2str'. Any changes made here will 
 *  be destroyed next time the tool is run. 
 *
 *  @date: {{ date }}
 */

#include <stdexcept>
{% for include in includes -%}
#include {{ include }}
{% endfor %}

{% for enum in enums %}

{% for namespace in enum.namespace -%}
namespace {{ namespace }} {
{% endfor %}

   std::string to_string(const {{ enum.name }} value) {
        switch(value) {
        {% for value in enum.entries %}
        case {{ enum.name }}::{{ value[0] }}: return "{{ value[0] }}";
        {% endfor %}

        default: return "Unknown Value";
        }
    }

   std::string get_description(const {{ enum.name }} value) {
        switch(value) {
        {% for value in enum.entries %}
        {% if value|length > 2 %}
        case {{ enum.name }}::{{ value[0 ]}}: return "{{ value[2] }}";
        {% else %}
        case {{ enum.name }}::{{ value[0] }}: return "{{ value[0] }}";
        {% endif %}
        {% endfor %}

        default: return "Unknown Value";
        }
    }

    {{ enum.name }} to_{{ enum.name }}(const std::string & value) {
        std::string result;

        {% for value in enum.entries %}
        {% if loop.index == 1 %}
        if (value == "{{ value[0] }}") {
            return {{ enum.name }}::{{ value[0] }};
        {% else %}
        else if (value == "{{ value[0] }}") {
            return {{ enum.name }}::{{ value[0] }};
        {% endif %}
        }
        {% endfor %}

        throw std::out_of_range(value);
    }

{% for namespace in enum.namespace %}
} // end namespace {{ namespace }}
{% endfor %}
{% endfor %} {# for enum in enums #}

"""

def generate_declarations(enums, includes):
    jinja = Environment(loader=None, trim_blocks=True, lstrip_blocks=True, keep_trailing_newline=True)
    template = jinja.from_string(declarations_template)

    return template.render(enums=enums, includes=includes, date=datetime.datetime.now())


def generate_definitions(enums, includes):
    jinja = Environment(loader=None, trim_blocks=True, lstrip_blocks=True, keep_trailing_newline=True)
    template = jinja.from_string(definitions_template)

    return template.render(enums=enums, includes=includes, date=datetime.datetime.now())


if __name__ == '__main__':

    argparser = argparse.ArgumentParser(
        prog='mkenum',
        description='Generate C++ enums & associated conversion methods'
    )

    argparser.add_argument('config_file', type=str, help='The configuration file containing the enums to be generated')
    args = argparser.parse_args()

    with open(args.config_file, 'r') as config_file:
        config = json.load(config_file)

    for file in config:
        # pprint.pprint(file)

        print("Generating declarations file '{}'".format(file['hpp_file']))

        # Make sure that the path exists. Spoiler alert: it probbaly doesn't
        header_folder = os.path.dirname(file['hpp_file'])
        if not os.path.exists(header_folder):
            os.makedirs(header_folder)

        with open(file['hpp_file'], 'w') as f:
            f.write(generate_declarations(file['enums'], file['header_includes']))

        print("Generating definitions file '{}'".format(file['cpp_file']))

        # Make sure that the path exists. Spoiler alert: it probbaly doesn't
        source_folder = os.path.dirname(file['cpp_file'])
        if not os.path.exists(source_folder):
            os.makedirs(source_folder)

        with open(file['cpp_file'], 'w') as f:
            f.write(generate_definitions(file['enums'], includes=file['source_includes']))

